#!/usr/bin/python

# by jhyu

import urllib2
import json
import ConfigParser
import sys
import os

ZBX_CONF_FILE = '/etc/zabbix/zabbix_agentd.conf'
API_CONF_FILE = '/etc/zabbix/auto_notice_api.conf'

class auto_notice(object):
    def __init__(self, config):
        self.config = config
        self.server = self.config.get('api', 'server')
        self.user = self.config.get('api', 'user')
        self.password = self.config.get('api', 'password')
        self.token = ''

        self.region = sys.argv[1]
        self.target = sys.argv[2]
        self.target_item = sys.argv[3]
        self.issue_type = sys.argv[4]

    def get_token(self):
        url = "%s/api-token-auth/" % self.server
        data = {
                'email': self.user, 
                'password': self.password
            }

        try:
            request = urllib2.Request(url)
            request.add_header('Content-Type', 'application/json')
            response = json.loads(urllib2.urlopen(request, json.dumps(data)).read())

            self.token = "JWT " + response['token']
        except Exception as e:
            output = "Got exception '%s'" % e
            zabbix_sender('auto.notice', output)
            sys.exit(1)

    def send_api(self):
        url = "%s/v1/auto_notice/issue/%s/%s/%s" % (self.server, self.region, self.target, self.target_item)
        data = "issue_type=%s" % self.issue_type

        try:
            request = urllib2.Request(url)
            request.add_header('Content-Type', 'application/x-www-form-urlencoded')
            request.add_header('Accept', 'application/json')
            request.add_header('Authorization', self.token)
            response = urllib2.urlopen(request, data=data)
         
            output = "Send - Target: %s, Target_item: %s, issue_type: %s" % (self.target, self.target_item, self.issue_type)
            zabbix_sender('auto.notice', output)
        except Exception as e:
            output = "Got exception '%s'" % e
            zabbix_sender('auto.notice', output)
            sys.exit(1)

def zabbix_sender(key, output):
    hostname = os.uname()[1]
    cmd = "zabbix_sender -s " + hostname + " -c " + ZBX_CONF_FILE + " -k " + key + " -o \"" + output + "\""
    print cmd
    #os.system(cmd)

def usage():
    print("usage: python auto_notice_api.py [region: <kilo>] [target: <rosurce>|<node>] [target_item] [issue_type]\n")

def main():

    if len(sys.argv) < 4:
        usage()
        sys.exit(1)

    config = ConfigParser.RawConfigParser()
    config.read(API_CONF_FILE)

    api = auto_notice(config)
    api.get_token()
    api.send_api()

if __name__ == "__main__":
    main()
